/**
 ** This file is part of Webscan 
 **	a web site fuzzer for common vulnerabilities
 **
 ** Copyright (C) 2003 gunzip 
 **
 **   <techieone@softhome.net>
 **   <avatar13@iname.com>
 **
 **   http://members.xoom.it/gunzip/
 **
 ** This program is free software; you can redistribute it and/or
 ** modify it under the terms of the GNU General Public License
 ** as published by the Free Software Foundation; either version 2
 ** of the License, or (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 **
 **/

#include "util.h"
#include "webscan.h"
#include <signal.h>

#define	OUTFILE	"results.html"

void sigint_handler( int sig )
{
   fprintf( stdout, DEF );
   fprintf( stderr, DEF );
   signal( SIGINT, SIG_DFL );
   raise( SIGINT );
}

int main( int argc, char * argv[] )
{
	FILE	* hack	= NULL;
	char	* data	= NULL;
	char	* host	= NULL;
	char	* page	= NULL;	
	char	* buff	= NULL;

	unsigned short port 	= 80;
	unsigned long 	ip		= 0;

	if ( argc != 2 )
	{
		fprintf( stdout, "__Usage: %s <url>\n", argv[0] );
		return -1;
	}

	signal( SIGINT, sigint_handler );

	unlink( OUTFILE );

	port = url_get_port( argv[1] );
	host = url_get_host( argv[1] );
	page = url_get_link( argv[1] );

	if ( (ip=resolve(host)) == -1 )
	{
		ERROR( "Can't resolve host" );
		return -1;
	}
	if ( page && (data = strchr( page, '?' )) )
			*data++ = 0;

	if ( !page || !data || !host )
	{
		ERROR( "Null pointer" );
		return -1;
	}

	fprintf( stdout, " -- Posting info to host=%s port=%d page=%s data=%s\n",
				host, port, page, data );
	
	fprintf( stdout, " -- Press any key to continue\n" );
	getchar();

	if ( (hack = http_request( host, data, page, port, ip, NULL, FALSE )) )
	{
		buff = (char *)xmalloc( BUFSIZ );
		while( net_fgets( buff, BUFSIZ, hack ) != NULL )
		{
			fprintf( stdout, "%s", buff );
			freport( OUTFILE, "%s", buff );
		}
	}
	puts("\n-- END --\n");
	return 0;
}
